"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var somfy_api_1 = require("../core/somfy-api");
var http_response_enum_1 = require("../enums/http-response.enum");
var discovery_1 = require("../core/discovery");
module.exports = function (RED) {
    RED.nodes.registerType('tahoma-config', function (props) {
        RED.nodes.createNode(this, props);
        this['pin'] = props.pin;
        this['name'] = props.name;
        this['token'] = props.token;
        this['url'] = props.url;
    });
    RED.httpAdmin.post('/somfy/get-token', function (request, response) { return __awaiter(void 0, void 0, void 0, function () {
        var _a, userId, userPassword, tahomaPin, token, _discovery, devices;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = request.body, userId = _a.userId, userPassword = _a.userPassword, tahomaPin = _a.tahomaPin;
                    return [4 /*yield*/, somfy_api_1.SomfyApi.getLocalToken(userId, userPassword, tahomaPin)];
                case 1:
                    token = _b.sent();
                    _discovery = new discovery_1.DiscoveryService();
                    return [4 /*yield*/, _discovery.getDevices(tahomaPin)];
                case 2:
                    devices = _b.sent();
                    if (token === null) {
                        response.status(http_response_enum_1.HttpResponse.BAD_REQUEST);
                        response.send();
                        return [2 /*return*/];
                    }
                    response.json({ token: token, devices: devices });
                    return [2 /*return*/];
            }
        });
    }); });
    RED.httpAdmin.get('/somfy/:account/devices', function (req, res) {
        var configNode = RED.nodes.getNode(req.params.account);
        var somfyApiClient = new somfy_api_1.SomfyApi(configNode);
        somfyApiClient
            .getDevices()
            .then(function (devices) {
            res.json(devices
                .filter(function (device) {
                return (device.controllableName !== 'io:StackComponent' &&
                    device.enabled &&
                    device.available &&
                    device.synced);
            })
                .map(function (device) {
                return {
                    id: device.deviceURL,
                    name: device.label,
                };
            }));
        })
            .catch(function () {
            res.status(http_response_enum_1.HttpResponse.SERVER_ERROR);
            res.send();
        });
    });
};
